diff --git a/plugins/omelasticsearch/omelasticsearch.c b/plugins/omelasticsearch/omelasticsearch.c
index 27b723a081..c041ee629a 100644
--- a/plugins/omelasticsearch/omelasticsearch.c
+++ b/plugins/omelasticsearch/omelasticsearch.c
@@ -401,9 +401,9 @@ ENDtryResume
 
 /* get the current index and type for this message */
 static void
-getIndexTypeAndParent(instanceData *pData, uchar **tpls,
-		      uchar **srchIndex, uchar **srchType, uchar **parent,
-		      uchar **bulkId)
+getIndexTypeAndParent(const instanceData *const pData, uchar **const tpls,
+		      uchar **const srchIndex, uchar **const srchType, uchar **const parent,
+		      uchar **const bulkId)
 {
 	if(tpls == NULL) {
 		*srchIndex = pData->searchIndex;
@@ -472,7 +472,10 @@ getIndexTypeAndParent(instanceData *pData, uchar **tpls,
 			}
 		}
 	}
-done:	return;
+done:
+	assert(srchIndex != NULL);
+	assert(srchType != NULL);
+	return;
 }
 
 
@@ -540,7 +543,9 @@ setPostURL(wrkrInstanceData_t *pWrkrData, instanceData *pData, uchar **tpls)
  * the batched request to elasticsearch
  */
 static size_t
-computeMessageSize(wrkrInstanceData_t *pWrkrData, uchar *message, uchar **tpls)
+computeMessageSize(const wrkrInstanceData_t *const pWrkrData,
+	const uchar *const message,
+	uchar **const tpls)
 {
 	size_t r = sizeof(META_STRT)-1 + sizeof(META_TYPE)-1 + sizeof(META_END)-1 + sizeof("\n")-1;
 
@@ -550,6 +555,10 @@ computeMessageSize(wrkrInstanceData_t *pWrkrData, uchar *message, uchar **tpls)
 	uchar *bulkId = NULL;
 
 	getIndexTypeAndParent(pWrkrData->pData, tpls, &searchIndex, &searchType, &parent, &bulkId);
+DBGPRINTF("computeMessageSize: message %p, searchIndex %p, searchType%p\n");
+DBGPRINTF("computeMessageSize: searchType %s\n", searchType);
+DBGPRINTF("computeMessageSize: searchIndex %s\n", searchIndex);
+DBGPRINTF("computeMessageSize: message %s\n", message);
 	r += ustrlen((char *)message) + ustrlen(searchIndex) + ustrlen(searchType);
 
 	if(parent != NULL) {
@@ -1146,6 +1155,7 @@ curlPost(wrkrInstanceData_t *pWrkrData, uchar *message, int msglen, uchar **tpls
 {
 	CURLcode code;
 	CURL *curl = pWrkrData->curlPostHandle;
+	char errbuf[CURL_ERROR_SIZE] = "";
 	DEFiRet;
 
 	pWrkrData->reply = NULL;
@@ -1157,28 +1167,31 @@ curlPost(wrkrInstanceData_t *pWrkrData, uchar *message, int msglen, uchar **tpls
 	curl_easy_setopt(curl, CURLOPT_WRITEDATA, pWrkrData);
 	curl_easy_setopt(curl, CURLOPT_POSTFIELDS, (char *)message);
 	curl_easy_setopt(curl, CURLOPT_POSTFIELDSIZE, msglen);
+	curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, errbuf);
 	code = curl_easy_perform(curl);
-	if (   code == CURLE_COULDNT_RESOLVE_HOST
-	    || code == CURLE_COULDNT_RESOLVE_PROXY
-	    || code == CURLE_COULDNT_CONNECT
-	    || code == CURLE_WRITE_ERROR
-	   ) {
+	DBGPRINTF("curl returned %lld\n", (long long) code);
+	if (code != CURLE_OK && code != CURLE_HTTP_RETURNED_ERROR) {
 		STATSCOUNTER_INC(indexHTTPReqFail, mutIndexHTTPReqFail);
 		indexHTTPFail += nmsgs;
-		DBGPRINTF("omelasticsearch: we are suspending ourselfs due "
-			  "to failure %lld of curl_easy_perform()\n",
-			  (long long) code);
+		LogError(0, RS_RET_SUSPENDED,
+			"omelasticsearch: we are suspending ourselfs due "
+			"to server failure %lld: %s", (long long) code, errbuf);
 		ABORT_FINALIZE(RS_RET_SUSPENDED);
 	}
 
-	DBGPRINTF("omelasticsearch: pWrkrData replyLen = '%d'\n", pWrkrData->replyLen);
-	if(pWrkrData->replyLen > 0) {
-		pWrkrData->reply[pWrkrData->replyLen] = '\0';
-		/* Append 0 Byte if replyLen is above 0 - byte has been reserved in malloc */
+	if(pWrkrData->reply == NULL) {
+		DBGPRINTF("omelasticsearch: pWrkrData reply==NULL, replyLen = '%d'\n",
+			pWrkrData->replyLen);
+	} else {
+		DBGPRINTF("omelasticsearch: pWrkrData replyLen = '%d'\n", pWrkrData->replyLen);
+		if(pWrkrData->replyLen > 0) {
+			pWrkrData->reply[pWrkrData->replyLen] = '\0';
+			/* Append 0 Byte if replyLen is above 0 - byte has been reserved in malloc */
+		}
+		DBGPRINTF("omelasticsearch: pWrkrData reply: '%s'\n", pWrkrData->reply);
+		CHKiRet(checkResult(pWrkrData, message));
 	}
-	DBGPRINTF("omelasticsearch: pWrkrData reply: '%s'\n", pWrkrData->reply);
 
-	CHKiRet(checkResult(pWrkrData, message));
 finalize_it:
 	incrementServerIndex(pWrkrData);
 	free(pWrkrData->reply);
